//
//  RCTMyWebViewManager.m
//  RNMyWebModule
//
//  Created by Elad on 15/06/2020.
//  Copyright © 2020 Facebook. All rights reserved.
//

#import "RCTHoneybookWebViewManager.h"
#import <React/RCTWebView.h>
#import <React/RCTUIManager.h>
#import "RCTHoneybookWebView.h"

static RCTHoneybookWebView* webview;

@interface RCTHoneybookWebViewManager () <RCTWebViewDelegate>

@end

@implementation RCTHoneybookWebViewManager { }

RCT_EXPORT_MODULE()

- (UIView *)view {
  return webview;
}

- (RCTHoneybookWebView *)webview {
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        webview = [RCTHoneybookWebView new];
        webview.delegate = self;
    });
    return webview;
}

RCT_EXPORT_METHOD(destroy:(nonnull NSNumber *)reactTag)
{
  [self.bridge.uiManager addUIBlock:^(__unused RCTUIManager *uiManager, NSDictionary<NSNumber *, RCTHoneybookWebView *> *viewRegistry) {
    RCTHoneybookWebView *view = viewRegistry[reactTag];
    if (![view isKindOfClass:[RCTHoneybookWebView class]]) {
      RCTLogError(@"Invalid view returned from registry, expecting RCTWebView, got: %@", view);
    } else {
        [view destroy];
    }
  }];
}

@end
